# @(#)13  1.7 src/cmdline/staging/scripts/list_partners.py, amws.cmdline, fim611, 060921a 9/18/06 16:18:29
# (C) Copyright International Business Machines Corporation 2005. All rights
# reserved.  U.S. Government Users Restricted Rights -- Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

from com.tivoli.am.fim.middlemanager.ssps import FederationManager, \
Federation, Partner
from fim_base import read_properties_file, get_domain_instance, prepare_mgr_objs
from fed_utils import list_partners, get_partners
from domain_utils import is_domain_present
from com.tivoli.am.fim.logging import FIMLoggerFactory
from com.tivoli.am.fim.logging import FIMLogger
from com.tivoli.am.fim.logging import FIMLevel
from com.tivoli.am.fim.i18n.msgs import CmdLineMessages
from jarray import array
from java.lang import Object
from com.tivoli.am.fim.logging import FIMLoggerConstants

# Set up FIMLogger
component_name = "StagingTools"
script_name = "list_partners.py"
method_name = script_name
class_name = "com.tivoli.am.fim.cmdline." + script_name[0:-3]
FIMLoggerFactory.enableStdout(FIMLevel.ALL)
FIMLoggerFactory.setPreferredFIMLoggerImpl(FIMLoggerConstants.FIMLOGGER_BASE_IMPL)
log = FIMLoggerFactory.getFIMLogger(component_name, class_name, CmdLineMessages.CLASS_NAME)

def usage():
    inserts = array([script_name],Object)
    log.logMessage(FIMLevel.INFO, method_name, CmdLineMessages.usage_list_partners, \
        inserts)
    raise SystemExit

if __name__ == 'main':
    
    if len(sys.argv) < 2 or len(sys.argv) > 3:
        usage()

    props_file = sys.argv[0]
    fed_name = sys.argv[1]
    props = read_properties_file(props_file)
    if not is_domain_present(props):
        raise SystemExit
            
    (fed_mgr, sec_tok_mgr) = prepare_mgr_objs(props, "list_partners")
    
    fed = fed_mgr.getFederationByDisplayName(fed_name, sec_tok_mgr)
    if not fed: # federation does not exist
        inserts = array([fed_name, props["Domain"]], Object)
        log.logMessage(FIMLevel.INFO, method_name, \
            CmdLineMessages.federation_does_not_exist_in_domain, inserts)
        raise SystemExit

    partner_id_map=get_partners(fed)
    if not partner_id_map.keys(): # no partners exist for given federation
        inserts = array([fed_name, props["Domain"]],Object)
        log.logMessage(FIMLevel.INFO, method_name, \
            CmdLineMessages.no_partners_exist_for_this_federation, inserts)
        raise SystemExit

    inserts = array([fed_name, props["Domain"]],Object)
    log.logMessage(FIMLevel.INFO, method_name, CmdLineMessages.printing_partners, \
        inserts)
        
    if len(sys.argv) == 3 and sys.argv[2] == "-show_ids":
        list_partners(fed, 1)
    else:
        list_partners(fed)
    

